#define VERSION "v4.2"

#include <alleg_graphics.h>
#include <alleg_conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <allegro.h>

#define UH(u) u/180.0*3.14159
#define MAXSPEED 40
#define xxtot 700
#define yytot 700
#define INITZIVOT 150
#define DEFAULT_RELOAD_TIME 45
#define MINA 13
#define VYDRZ_POLICKA 5
#define POLICKO_MINA  99
#define POLICKO_MINIMINA 98
#define MAX_MINIBOD   600
#define MAX_SHOTS 15

#define SCORE_FOR_VICTORY 5
#define SCORE_FOR_UF_VICTORY 3
#define SCORE_FOR_FLAWLESS_VICTORY 10


#define MINE_DAMAGE 5
#define MINE_DIAGONAL_DAMAGE 2
#define MINIMINE_DAMAGE 5
#define MINIMINE_DIAGONAL_DAMAGE 2
#define TILE_DAMAGE 2
#define TILE_DIAGONAL_DAMAGE 2
#define ENERGIA_TO_EXPLODE 254
#define DIAGONAL_DAMAGE_ENABLED

#define cisti while(kbhit()) getch()
#define cg cisti; getch()

#define TILES 200
#define BYTES_PER_LEVEL 22100


#define LANGUAGES 2
#define LANG_ENG 0
#define LANG_SVK 1

#define NUM_BONUS 8
#define BONUS_GAUSS_CANNON 1
#define BONUS_BACKFIRE 2
#define BONUS_TWO_WAY_FIRE 3
#define BONUS_WIDE_SHOT 4
#define BONUS_FAST_RELOAD 5
#define BONUS_15_SHOTS 6
#define BONUS_TOUCH_OF_DEATH 7
#define BONUS_SHIELD_RESTORE 8



typedef struct {
	char speed[LANGUAGES][15];
	char or[LANGUAGES][6];
	char controls[LANGUAGES][10];
	char pre2[LANGUAGES][14];
	char pre3[LANGUAGES][14];
	char press[LANGUAGES][7];
	char created_by[LANGUAGES][20];
	char speed_value[LANGUAGES][4][11];
	char keyb1[LANGUAGES][19];
	char keyb2[LANGUAGES][23];
	char keyb3[LANGUAGES][19];
	char flawless_victory[LANGUAGES][17];
	char uf_victory[LANGUAGES][17];
	char remiza[LANGUAGES][25];
	char scores_after_round[LANGUAGES][19];
	char round_winner[LANGUAGES][13];
	char points[LANGUAGES][3][7];
	char for_hits[LANGUAGES][20];
	char for_victory[LANGUAGES][13];
	char bonus_enabled[LANGUAGES][31];
	char level_name[LANGUAGES][15];
	char enter_for_round[LANGUAGES][35];
	char esc_for_quit[LANGUAGES][20];
	char note[LANGUAGES][70];
	char final_results[LANGUAGES][20];

} TEXT;




typedef struct {
	signed int a[10], b[10], c[10];
	signed int px[11], py[11];
	signed int xx, yy;
} POSITION;

typedef struct {
	int smer;
	unsigned int x, y;
	int xx, yy;
	int c;
	int zivot;
	int exist;
} STRELA;

typedef struct {
	int x1, y1, x2, y2, c;
	int exist;
	int xx, yy;
} CIARA;

typedef struct {
	int x, y, xx, yy, c;
	int exist;
} BODY;

typedef struct {
	int x, y, xx, yy, exist;
	char c;
} BOD2;

typedef struct {
	unsigned int x, y;
	long rychlost;
	int stit;
	int exist, aktiv;
	int strely, akstrely;		// -> Pocet striel
	int cas, casnab;
	int reload_time, default_reload_time, shots_left, max_shots;
	int c;
	int smer;
	char left;				//|
	char right;				//|
	char up;				//| -> Klavesy na ovladanie
	char down;				//|
	char down2;				//|
	int fire;				//|
	long int xxakt, yyakt;
	int vybuch;
	int minivybuch;
	long int pripx, pripy;
	int score, score_hits, score_victory;
	int bonus;
	int bonus_time, bonus_max_time, bonus_color;

	BODY bod[32];
	CIARA ciara[11];
	STRELA strela[MAX_SHOTS];
} TANK;

int zapas (void);
void set_interrupts (void);
void restore_interrupts (void);
void cakaj (void);
void initgraphics (void);
void closegraphics (void);
int getfarba (void);
void setminibod (int i, int x, int y, int exist);
void initminibod (void);
void addminibod (int x, int y, int num);
void moveminibod (void);
void klavesnica_zpomal (void);
void klavesnica_zrychli (void);
void kocka (int x, int y, int c);
void kocka2 (int x, int y, int c);

//int  get_bit(char a,int bit);
void nacitaj_data (void);
void spravpole (int cislo);
void vykresli_pole (void);
void naktank (int t);
void zmaztank (int t);
void vykresli_udaje (void);
void vypocet (void);
void vytvor_vybuch (int k);
void napis_mna (void);
void napis_ovladanie (void);
void napis_pratanky (void);
void napis_rychlost (int r);
void setup (void);
void napis_znova (void);
void zbuchni_tanky (char *name);
void exitas (int a);
void make_damage (int x, int y, unsigned int damage);
void text_char (int x, int y, char c, int color);
void text_box (int x1, int y1, int x2, int y2, int type, int color);
void text_hline (int x1, int y, int x2, int type, int type_bord, int color);
int correct_lang_quantity (int q);
int hextoint (int a);
void colortext (char *text);
void show_keyboard (void);
void set_keyboard_interrupt (void);
void restore_keyboard_interrupt (void);
int is_visible (int x, int y);
void draw_energy_bar (int i, int e);
void erase_energy_bar (int i, int e);
void modify_speed (int i, int inc);
void draw_speed_bar (int i, int r, int col);
void modify_speed (int i, int inc);
int minimum (int a, int b);
int maximum (int a, int b);
void draw_ammo_bar (int i, int bari);
void erase_ammo_bar (int i, int bari);
void redraw_ammo (int i);
int count_shots (int i);
void erase_bonus_name (int i);
void draw_bonus_name (int i, int bonus);
void manage_bonus (int i, int bonus, int is_new);
void init_bonus (void);
void draw_bonus_tile (void);
void erase_bonus_tile (void);
void fire_shot (int i, int pp2, int pp1);
void text_fill_line (int x1, int y, int x2, char c, int color);
long filesize (FILE * stream);
int get_num_rounds (void);


extern FONT *fontik_system;
extern DATAFILE *tanky_datafile;
extern SAMPLE *sample1000Hz;
extern BITMAP *obrazok[TILES];
extern BITMAP *info_icon[3];
extern unsigned char pole[81][61];
extern unsigned char vydrz[81][61];
extern unsigned char cycle_min[81][61];
extern unsigned char cycle_max[81][61];
extern unsigned char cycle_akt[81][61];
extern char bonus_name[NUM_BONUS + 1][10];

extern int lang;
extern int bonus_enable;
extern const TEXT text;

extern int poziciax[4], poziciay[4];
extern int pocethracov;
extern int kolo;
extern int body[4];
extern int energy_bar_color[5];
extern char level_description[61];

extern int grip, speedmul, reargrip, strelamul;

extern FILE *f;
extern TANK tank[4];
extern POSITION pos[32];


extern int last_minibod;
extern BOD2 minibod[MAX_MINIBOD + 16];

extern volatile unsigned char a;
extern volatile char *klavesy;
extern volatile int moze, cas, tiky;
extern int bonusx, bonusy, bonus_time, bonus_etap, bonus_count, bonus_color;
extern int is_final_round;

#define      SPACE_KEY   KEY_SPACE
#define      BSPACE_KEY   14
#define      BCKSPACE_KEY 14
#define      BKSPACE_KEY  14
#define      BACK_SPACE   14
#define      ENTER_KEY   KEY_ENTER
#define      ESC_KEY     KEY_ESC
#define      SPACE       57
#define      UP_KEY      KEY_UP
#define      DOWN_KEY    KEY_DOWN
#define      LEFT_KEY    KEY_LEFT
#define      RIGHT_KEY   KEY_RIGHT
#define      INS_KEY     KEY_INSERT
#define      DEL_KEY     83
#define      HOME_KEY    71
#define      END_KEY     79
#define      PGUP_KEY    73
#define      PGDN_KEY    81
#define      CTRL_KEY    29
#define      ALT_KEY     56
#define      LSHIFT_KEY  42
#define      RSHIFT_KEY  56
#define      NUM_LOCK    69
#define      CAPS_LOCK   29
#define      SCROLL_LOCK 70
#define      PRINT_SCREEN 70
#define      PRINTSCREEN 70
#define      TAB_KEY     KEY_TAB
#define      F1_KEY      59
#define      F2_KEY      60
#define      F3_KEY      61
#define      F4_KEY      62
#define      F5_KEY      63
#define      F6_KEY      64
#define      F7_KEY      65
#define      F8_KEY      66
#define      F9_KEY      67
#define      F10_KEY     KEY_F10
#define      F11_KEY     87
#define      F12_KEY     88
#define      A_KEY       KEY_A
#define      B_KEY       KEY_B
#define      C_KEY       KEY_C
#define      D_KEY       KEY_D
#define      E_KEY       KEY_E
#define      F_KEY       KEY_F
#define      G_KEY       KEY_G
#define      H_KEY       KEY_H
#define      I_KEY       KEY_I
#define      J_KEY       KEY_J
#define      K_KEY       KEY_K
#define      L_KEY       KEY_L
#define      M_KEY       KEY_M
#define      N_KEY       KEY_N
#define      O_KEY       KEY_O
#define      P_KEY       KEY_P
#define      Q_KEY       KEY_Q
#define      R_KEY       KEY_R
#define      S_KEY       KEY_S
#define      T_KEY       KEY_T
#define      U_KEY       KEY_U
#define      V_KEY       KEY_V
#define      W_KEY       KEY_W
#define      X_KEY       KEY_X
#define      Y_KEY       KEY_Y
#define      Z_KEY       KEY_Z
#define      A1_KEY      KEY_1
#define      A2_KEY      KEY_2
#define      A3_KEY      KEY_3
#define      A4_KEY      KEY_4
#define      A5_KEY      KEY_5
#define      A6_KEY      KEY_6
#define      A7_KEY      KEY_7
#define      A8_KEY      KEY_8
#define      A9_KEY      KEY_9
#define      A0_KEY      KEY_0
#define VLNKA_KEY       41
#define BKLASH_KEY      43
#define EQUAL_KEY       13
#define ROVNA_SA        13
#define MINUS_KEY       12
#define LOMENO_KEY      53
#define LOMENE_KEY        LOMENO_KEY
#define CIARKA_KEY      51
#define BODKA_KEY       KEY_STOP
#define DVOJBODKA_KEY   KEY_COLON
#define BODKOCIARKA_KEY   DVOJBODKA_KEY
#define UVODZOVKA_KEY   KEY_QUOTE
#define UVODZOVKY_KEY     UVODZOVKA_KEY
#define APOSTROF_KEY      UVODZOVKA_KEY
#define ZATVORKA1_KEY   26
#define ZATVORKA2_KEY   27

#define GRAYPLUS_KEY   78
#define GRAYMINUS_KEY  74
#define GRAYKRAT_KEY   55
#define GRAYLOMENE_KEY 53
#define GRAYLOMENO_KEY   GRAYLOMENE_KEY
#define GRAY0_KEY      82
#define GRAY1_KEY      79
#define GRAY2_KEY      80
#define GRAY3_KEY      81
#define GRAY4_KEY      75
#define GRAY5_KEY      76
#define GRAY6_KEY      77
#define GRAY7_KEY      71
#define GRAY8_KEY      72
#define GRAY9_KEY      73
